<template>
  <div class="flow-userwrap">
    <div class="title">
      {{$t('userSelectBox')}}
    </div>
    <div class="search">
      <mt-search
        v-model="keyWord"
        @keyup.enter.native="search"
        :cancel-text="$t('cancel')"
        :placeholder="$t('search')">
      </mt-search>
    </div>
    <div class="list-wrap">
      <div class="user-list" v-for="(item, index) in approverList" :key="index">
        <div class="list-check">
          <label class="mint-checklist-label pending-radio">
            <span class="mint-checkbox">
              <input 
                type="checkbox" 
                class="mint-checkbox-input"   
                v-model="checkVal" 
                :value="item.id" 
                @change="handleSelectionChange($event, item)"
                />
              <span class="mint-checkbox-core"></span>
            </span>
          </label>
        </div>
        <div class="photo">
          <img src="../assets/images/face.jpg">
        </div>
        <div class="list-info">{{item.name}}</div>
      </div>
    </div>
    <div class="bottom-btns">
      <div class="selected">{{$t('select_dept')}}:{{checkVal.length}}/{{approverList.length}}</div>
      <mt-button class="btn" type="primary" size="small" @click="onOK">{{$t('verify')}}</mt-button>
    </div>
  </div>
</template>

<script>
export default {
  props: ["openParams","designatedApproverList"],
  data: function() {
    return {
      checkVal:[],
      keyWord:'',
      value:'',
      selectRow:[],
    };
  },
  created() {
    this.getApproverList();
  },

  mounted() {
    
  },
  methods: {
    search() {
      this.$api.getSearch(this.keyWord, {
        onSucess: response => {
          this.approverList = response.data.data.datas;
          this.keyWord = ""
        }
      })
    },
    handleSelectionChange(ev, item) {
      let val = this.checkVal;
      if(ev.target.checked && val.length > 0) {
        for(let i=0; i<val.length; i++) {
          if(val[i] == item.id) {
            this.selectRow.push(item);
          }
        }
      }else {
        for(let j=0; j<this.selectRow.length; j++) {
          if(item.id == this.selectRow[j].id) {
            this.selectRow.splice(j,1);
          }
        }
      }
    },
    getApproverList() {
      this.approverList = this.designatedApproverList.datas;
    },
    onOK(){
      let hostOrCohostList = [];
      this.selectRow.forEach(items => {
        let obj = {};
        for (let key in items) {
          if(key == "id" || key == "name") {
            obj[key] = items[key];
          }
        }
        hostOrCohostList.push(obj);
      });
      this.$emit("action",hostOrCohostList); //调用父组件selectHostOrCohost()方法
    },
  }
};
</script>